
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_memberships = await db.user_memberships.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        next_billing_at: data.next_billing_at
        ||
        null
            ,
            
        cancelled_at: data.cancelled_at
        ||
        null
            ,
            
        ends_at: data.ends_at
        ||
        null
            ,
            
        price_supercharged: data.price_supercharged
        ||
        null
            ,
            
        perks_snapshot: data.perks_snapshot
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_memberships.setUser( data.user || null, {
            transaction,
        });
        
        await user_memberships.setMembership_plan( data.membership_plan || null, {
            transaction,
        });
        

        

        

        return user_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                next_billing_at: item.next_billing_at
            ||
            null
            ,
            
                cancelled_at: item.cancelled_at
            ||
            null
            ,
            
                ends_at: item.ends_at
            ||
            null
            ,
            
                price_supercharged: item.price_supercharged
            ||
            null
            ,
            
                perks_snapshot: item.perks_snapshot
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_memberships = await db.user_memberships.bulkCreate(user_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return user_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_memberships = await db.user_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.next_billing_at !== undefined) updatePayload.next_billing_at = data.next_billing_at;
        
        
        if (data.cancelled_at !== undefined) updatePayload.cancelled_at = data.cancelled_at;
        
        
        if (data.ends_at !== undefined) updatePayload.ends_at = data.ends_at;
        
        
        if (data.price_supercharged !== undefined) updatePayload.price_supercharged = data.price_supercharged;
        
        
        if (data.perks_snapshot !== undefined) updatePayload.perks_snapshot = data.perks_snapshot;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_memberships.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.membership_plan !== undefined) {
            await user_memberships.setMembership_plan(
              
              data.membership_plan,
              
              { transaction }
            );
        }
        

        
        

        

        return user_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_memberships = await db.user_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_memberships) {
                await record.destroy({transaction});
            }
        });


        return user_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_memberships = await db.user_memberships.findByPk(id, options);

        await user_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_memberships.destroy({
            transaction
        });

        return user_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_memberships = await db.user_memberships.findOne(
            { where },
            { transaction },
        );

        if (!user_memberships) {
            return user_memberships;
        }

        const output = user_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_memberships.getUser({
            transaction
        });
        
        
        output.membership_plan = await user_memberships.getMembership_plan({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.membership_plans,
        as: 'membership_plan',
        
        where: filter.membership_plan ? {
          [Op.or]: [
            { id: { [Op.in]: filter.membership_plan.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.membership_plan.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.perks_snapshot) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_memberships',
                        'perks_snapshot',
                        filter.perks_snapshot,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            started_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    ends_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.next_billing_atRange) {
                const [start, end] = filter.next_billing_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    next_billing_at: {
                    ...where.next_billing_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    next_billing_at: {
                    ...where.next_billing_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cancelled_atRange) {
                const [start, end] = filter.cancelled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cancelled_at: {
                    ...where.cancelled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cancelled_at: {
                    ...where.cancelled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ends_atRange) {
                const [start, end] = filter.ends_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.price_superchargedRange) {
                const [start, end] = filter.price_superchargedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    price_supercharged: {
                    ...where.price_supercharged,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    price_supercharged: {
                    ...where.price_supercharged,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_memberships',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_memberships.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

